package com.younike.common.quartz.util;

import com.younike.common.quartz.job.BaseJob;


/**
 * quartz 工具类
 */
public class JobUtils {

    /**
     * 根据全类名获取Job实例
     *
     * @param classname Job全类名
     * @return {@link BaseJob} 实例
     * @throws Exception 泛型获取异常
     */
    public static BaseJob getClass(String classname) throws Exception {
        Class<?> clazz = Class.forName(classname);
        return (BaseJob) clazz.newInstance(); // 类加载机制（java9后推荐使用：clazz.getDeclaredConstructor().newInstance()）
    }

}
