package com.younike.service.pojo;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.younike.common.utils.poi.Excel;
import lombok.Data;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.Version;
import com.younike.common.core.domain.BaseEntity;

/**
 * 会员用户对象 app_member
 *
 * @author dail
 * @date 2022-05-24
 */
@Data
public class AppMember extends BaseEntity {
    private static final long serialVersionUID=1L;

    /** 会员用户id */
    @TableId(type = IdType.ASSIGN_UUID)
    private String appMemberId;

    /** 注册手机号 */
    private String phone;

    /** 昵称 */
    private String nickName;

    /** 帐号状态（0-正常；1-停用；默认0） */
    private String status;

    /** 性别（0-男；1-女；2-未知；默认2） */
    private String gender;

    /** 头像图片（暂不支持上传头像） */
    private String avatar;

    /** 加密后的密码 */
    private String password;

    /** 最近登录IP */
    private String lastLoginIp;

    /** 最近登录时间zzzz */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private String lastLoginDate;

    /** 删除标签(0-正常；1-已删除；默认0) */
    private String delFlag;

    /** 创建人ID */
    private String createdBy;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private String createdTime;

    /** 更新人ID */
    private String updatedBy;

    /** 更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private String updatedTime;

    /** 版本号(默认0) */
    @Version
    private Long version;



}
