package com.younike.service.pojo;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.younike.common.utils.poi.Excel;
import lombok.Data;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.Version;
import com.younike.common.core.domain.BaseEntity;

/**
 * 会员收藏记录对象 app_member_collection
 *
 * @author dail
 * @date 2022-05-24
 */
@Data
public class AppMemberCollection extends BaseEntity {
    private static final long serialVersionUID=1L;

    /** 会员收藏记录id */
    @TableId(type = IdType.ASSIGN_UUID)
    private String memberCollectionId;

    /** 会员ID（关联表app_member) */
    private String appMemberId;

    /** 收藏分类；枚举：001-门店、002-代金券商品、003-团购套餐商品 */
    private String collectionType;

    /** 收藏内容ID（门店或商品id） */
    private String collectionItemId;

    /** 删除标签(0-正常；1-已删除；默认0) */
    private String delFlag;

    /** 创建人ID */
    private String createdBy;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private String createdTime;

    /** 更新人ID */
    private String updatedBy;

    /** 更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private String updatedTime;

    /** 版本号(默认0) */
    @Version
    private Long version;



}
