package com.younike.service.pojo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.Version;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.younike.common.core.domain.BaseEntity;
import lombok.Data;

/**
 * 会员日记对象 app_member_vlog
 *
 * @author dail
 * @date 2022-05-24
 */
@Data
public class AppMemberVlog extends BaseEntity {
    private static final long serialVersionUID=1L;

    /** 会员日记id */
    @TableId(type = IdType.ASSIGN_UUID)
    private String memberVlogId;

    /** 会员用户ID（关联表app_member) */
    private String appMemberId;

    /** 日记标题 */
    private String vlogTitle;

    /** 日记内容（可嵌入店铺链接、商品链接） */
    private String vlogBody;

    /** Vlog状态；枚举：0-草稿、1-已发布 */
    private String vlogStatus;

    /** 发布时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private String publishedTime;

    /** 删除标签(0-正常；1-已删除；默认0) */
    private String delFlag;

    /** 创建人ID */
    private String createdBy;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private String createdTime;

    /** 更新人ID */
    private String updatedBy;

    /** 更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private String updatedTime;

    /** 版本号(默认0) */
    @Version
    private Long version;



}
